function [z,solution_time,niter,B,x_B,optimal,dense]=simplex(A,c,b,eqin,minmax,name,jb,re_inv,tol1,tol2,tol3,c0)
if minmax==1
   c=-c;
end
[m n]=size(A);
time=cputime;
%----------   1-----------
if tol1==0
   tol1 = max(m,n)*eps*norm(A,'inf');   
elseif tol1==1
   tol1=10e-10;
elseif tol1==2
   tol1=10e-8;
else
   tol1=10e-6;
end
%----------   2-----------
if tol2==0
   tol2 = max(m,n)*eps*norm(A,'inf');   
elseif tol2==1
   tol2=10e-10;
elseif tol2==2
   tol2=10e-8;
else
   tol2=10e-6;
end
%----------   3-----------
if tol3==0
   tol3 = max(m,n)*eps*norm(A,'inf');   
elseif tol3==1
   tol3=10e-10;
elseif tol3==2
   tol3=10e-8;
else
   tol3=10e-6;
end
%---------- ---------------
ncol=n;
nz=nnz(A);
dense=(nz/(m*n))*100;
disp('  (%)    A :')
disp(dense)
counter=1;
%-------  ----------
for i=colon(1,m)
   if eqin(i)==-1
      ei=zeros(m,1);
      ei(i)=1;
      A=[A ei];
      c=[c 0];
   end
   if eqin(i)==1
      ei=zeros(m,1);
      ei(i)=-1;
      A=[A ei];
      c=[c 0];
   end
end
%---------   ---------------
x_B=zeros(m,1);
n=length(c);
B=[jb ncol+1:n];
N=setdiff([1:ncol],B);
%--------        --------
B_inv=inv(A(:,B));
x_B=B_inv*b;
if all(x_B>=0)
   s_N=c(:,N)-c(:,B)*B_inv*A(:,N);
   phaseI_II=0;
   msgbox('      ','')
end
%--------------Phase II---------------
niter=0;
while phaseI_II==0
   if all(s_N>=0)
      optimal=1;
      solution_time=cputime-time;
      z=c(:,B)*x_B+c0;
      if minmax==1
         z=-z;
      end
      return;
   else
      [p t]=min(s_N);
      l=N(t);
      h=B_inv*A(:,l);
      toler=abs(h)<=tol3;
      h(toler==1)=0;
      if all(h<=0)
         solution_time=cputime-time;
         optimal=0;
         disp(' ..  ')
         return;
      end
      mrt=find(h>0);
      [p r]=min(x_B([mrt])./h([mrt]));
      r=mrt(r);
      k=B(r);
      B(r)=l;
      N(t)=k;
      if niter==counter*re_inv
         B_inv=inv(A(:,B));
         counter=counter+1;
      else
         E_inv=speye(m);
         E_inv(:,r)=-h(1:m)/h(r);
         E_inv(r,r)=1/h(r);
         B_inv=E_inv*B_inv;clear E_inv;
      end
   end
   x_B=B_inv*b;
   toler=abs(x_B)<=tol1;
   x_B(toler==1)=0;
   s_N=c(:,N)-c(:,B)*B_inv*A(:,N);
   toler=abs(s_N)<=tol2;
   s_N(toler==1)=0;
   niter=niter+1;
end